package uk.ac.ox.cs.goalDriven.chaseBench;

import java.io.File;

public class ChaseInstance {

    public static File s_scenariosRoot = new File("/home/SERILOCAL/efi.tsamoura/chasebench/scenarios");
    public static File s_resultsRoot = new File("./QA-TGDs");
    public static File s_RDFdataRoot = new File("./RDFdata");

    public int m_numberOfThreads = 1;
    public String m_fullName = null;
    public File m_sSchemaFile = null;
    public File m_tSchemaFile = null;
    public File m_sourceInstanceRoot = null;
    public File m_stTGDsFile = null;
    public File m_tTGDsFile = null;
    public File m_tEGDsFile = null;
    public File m_outputRoot = null;
    public File m_targetInstanceRoot = null;
    public File m_queriesRoot = null;
    public File m_queryResultsRoot = null;
    public File m_transformedProgramsRoot = null;

    public void initialize(String scenarioNamePrefix, String scenarioName, String scenarioNameSuffix,
            String dataVariantName, boolean isMagic) {
        m_fullName = "";
        if (scenarioNamePrefix != null && scenarioNamePrefix.length() != 0)
            m_fullName += scenarioNamePrefix + "-";
        m_fullName += scenarioName;
        if (scenarioNameSuffix != null && scenarioNameSuffix.length() != 0)
            m_fullName += "-" + scenarioNameSuffix;
        if (dataVariantName != null && dataVariantName.length() != 0)
            m_fullName += "-" + dataVariantName;

        File scenarioRoot = s_scenariosRoot;
        if (scenarioNamePrefix != null && scenarioNamePrefix.length() != 0)
            scenarioRoot = new File(scenarioRoot, scenarioNamePrefix);
        scenarioRoot = new File(scenarioRoot, scenarioName);
        if (scenarioNameSuffix != null && scenarioNameSuffix.length() != 0)
            scenarioRoot = new File(scenarioRoot, scenarioNameSuffix);
        m_outputRoot = new File(s_resultsRoot, m_fullName);
        m_sSchemaFile = new File(scenarioRoot, "schema/" + scenarioName + ".s-schema.txt");
        m_tSchemaFile = new File(scenarioRoot, "schema/" + scenarioName + ".t-schema.txt");
        m_sourceInstanceRoot = getVariantDirectory(new File(scenarioRoot, "data"), dataVariantName);
        m_stTGDsFile = new File(scenarioRoot, "dependencies/" + scenarioName + ".st-tgds.txt");
        m_tTGDsFile = new File(scenarioRoot, "dependencies/" + scenarioName + ".t-tgds.txt");
        if (!m_tTGDsFile.exists())
            m_tTGDsFile = null;
        m_tEGDsFile = new File(scenarioRoot, "dependencies/" + scenarioName + ".t-egds.txt");
        if (!m_tEGDsFile.exists())
            m_tEGDsFile = null;
        m_targetInstanceRoot = new File(m_outputRoot, "instance");
        m_queriesRoot = getVariantDirectory(new File(scenarioRoot, "queries"), dataVariantName);
        m_queryResultsRoot = null;
        if (m_queriesRoot.exists()) {
            if (isMagic) {
                m_queryResultsRoot = new File(m_outputRoot, "magic-query-results");
                m_transformedProgramsRoot = new File(m_outputRoot, "magic-programs");
                m_transformedProgramsRoot.mkdirs();
            } else
                m_queryResultsRoot = new File(m_outputRoot, "query-results");
        } else
            m_queriesRoot = null;
    }

    public boolean usesEquality() {
        return m_tEGDsFile != null;
    }

    protected static File getVariantDirectory(File parentDirectory, String variantName) {
        if (variantName != null && variantName.length() != 0) {
            File variantDirectory = new File(parentDirectory, variantName);
            if (variantDirectory.exists())
                return variantDirectory;
        }
        return parentDirectory;
    }
}
