package uk.ac.ox.cs.goalDriven.QA.magic;

import java.util.*;

class Graph<T> {

    private Map<T, List<T>> m_map = new HashMap<>();

    public void addVertex(T s) {
        m_map.put(s, new LinkedList<T>());
    }

    public Set<T> getVertices() {
        return m_map.keySet();
    }

    public void addEdge(T source, T destination) {
        if (!m_map.containsKey(source))
            addVertex(source);
        if (!m_map.containsKey(destination))
            addVertex(destination);
        m_map.get(source).add(destination);
    }

    public Boolean hasVertex(T s) {
        if (m_map.containsKey(s))
            return true;
        return false;
    }

    public Boolean hasEdge(T s, T d) {
        if (m_map.get(s).contains(d))
            return true;
        return false;
    }

    public T findSync(T s) {
        if (!m_map.containsKey(s))
            return s;
        List<T> nodes = m_map.get(s);
        if(nodes.size() == 0)
            return s;
        for(T d:nodes) {
            return findSync(d);
        }
        return null;
    }

}
