package uk.ac.ox.cs.goalDriven.QA.processors;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import uk.ac.ox.cs.goalDriven.model.Predicate;
import uk.ac.ox.cs.goalDriven.model.Rule;
import uk.ac.ox.cs.goalDriven.processors.InputProcessor;

public class RuleSubsumption implements InputProcessor {
    protected final InputProcessor m_inputProcessor;
    protected final List<Rule> m_rules;

    public RuleSubsumption(InputProcessor inputProcessor) {
        m_inputProcessor = inputProcessor;
        m_rules = new ArrayList<Rule>();
    }

    public void startProcessing() {
        m_inputProcessor.startProcessing();
    }

    public void processRule(Rule rule) {
    	for (Rule existingRule : m_rules)
    		if (existingRule.getSubsumingSubstitution(rule) != null)
    			return;
    	Iterator<Rule> iterator = m_rules.iterator();
    	while (iterator.hasNext()) {
    		Rule existingRule = iterator.next();
    		if (rule.getSubsumingSubstitution(existingRule) != null)
    			iterator.remove();
    	}
    	m_rules.add(rule);
    }

    public void processFact(Predicate predicate, List<String> argumentLexicalForms) {
        m_inputProcessor.processFact(predicate, argumentLexicalForms);
    }

    public void endProcessing() {
        for (Rule rule : m_rules)
        	m_inputProcessor.processRule(rule);
        m_inputProcessor.endProcessing();
    }
}
