package uk.ac.ox.cs.goalDriven.QA.utilities;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class FormatRewriting {

    public static void main(String[] args) throws Exception {

        String path = "/home/SERILOCAL/efi.tsamoura/chasebench/scenarios/doctors/dependencies/";
        String inputFileName = "doctors.t-egds.txt";
        String outputFileName = inputFileName + ".new";
        File inputFile = new File(path + inputFileName);
        try (BufferedReader bufferedReader = new BufferedReader(new FileReader(inputFile))) {

            FileWriter outputFileWriter = new FileWriter(path + outputFileName);
            String rule;
            while ((rule = bufferedReader.readLine()) != null) {
                // Split the string based on ->
                String body = rule.split("->")[0];
                String head = rule.split("->")[1];
                head = head.replace('.', ' ');
                // Split based on commas in the head
                String[] atoms = head.split(",");

                List<String> newHeadAtoms = new ArrayList<>();
                for (String atom : atoms) {
                    String[] variables = atom.split("=");

                    String X = variables[0].replaceAll("\\s", "");
                    String Y = variables[1].replaceAll("\\s", "");
                    // Split based on X = Y
                    // Rewrite the atom to =(X,Y)
                    String newHeadAtom = "=(" + X + ", " + Y + ")";
                    newHeadAtoms.add(newHeadAtom);
                }

                String newRule = body + " -> ";
                for (int index = 0; index < newHeadAtoms.size(); ++index) {
                    newRule += newHeadAtoms.get(index);
                    if (index < newHeadAtoms.size() - 1)
                        newRule += ", ";
                }
                // write the string to a new file
                outputFileWriter.write(newRule + " .\n");
            }

            outputFileWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
