package uk.ac.ox.cs.goalDriven.format;

import java.io.PrintWriter;
import java.io.Writer;
import java.util.List;

import uk.ac.ox.cs.goalDriven.model.Predicate;
import uk.ac.ox.cs.goalDriven.model.Rule;
import uk.ac.ox.cs.goalDriven.processors.InputProcessor;

public class CommonFormatProcessor implements InputProcessor {
    protected final PrintWriter m_output;

    public CommonFormatProcessor(Writer output) {
        if (output == null)
            m_output = null;
        else if (output instanceof PrintWriter)
            m_output = (PrintWriter) output;
        else
            m_output = new PrintWriter(output);
    }

    public void startProcessing() {
    }

    public void processRule(Rule rule) {
        rule.print(m_output);
        m_output.println();
    }

    public void processFact(Predicate predicate, List<String> argumentLexicalForms) {
        predicate.print(m_output);
        m_output.print('(');
        for (int index = 0; index < argumentLexicalForms.size(); ++index) {
            if (index != 0)
                m_output.print(',');
            m_output.print(argumentLexicalForms.get(index));
        }
        m_output.println(") .");
    }

    public void endProcessing() {
        m_output.close();
    }
}
