package uk.ac.ox.cs.goalDriven.model;

import java.io.PrintWriter;
import java.io.Serializable;
import java.util.Collection;
import java.util.Map;

public class Constant extends Term implements Serializable {
    private static final long serialVersionUID = 3347513364700246887L;

    protected final String m_lexicalForm;

    protected Constant(String lexicalForm) {
        m_lexicalForm = lexicalForm;
    }

    public String getLexicalForm() {
        return m_lexicalForm;
    }

    public boolean isGround() {
        return true;
    }

    public Term applySubstitution(Map<Variable, ? extends Term> substitution) {
        return this;
    }

    public Term applyMapping(Map<? extends Term, ? extends Term> mapping) {
        Term substitutedTerm = mapping.get(this);
        if (substitutedTerm == null)
            return this;
        else
            return substitutedTerm;
    }

    public void getFreeVariables(Collection<Variable> collection) {
    }

    public void getConstants(Collection<Constant> collection) {
        collection.add(this);
    }

    public void getFunctions(Map<Function,Integer> collection) {
    }

    public int depth() {
        return 0;
    }

    public void toString(StringBuilder builder) {
        builder.append(m_lexicalForm);
    }

    public void print(PrintWriter output) {
        output.print(m_lexicalForm);
    }

    protected Object readResolve() {
        return s_interningManager.intern(this);
    }

    protected static final InterningManager<Constant> s_interningManager = new InterningManager<Constant>() {
        protected boolean equal(Constant object1, Constant object2) {
            return object1.m_lexicalForm.equals(object2.m_lexicalForm);
        }

        protected int getHashCode(Constant object) {
            return object.m_lexicalForm.hashCode() * 7;
        }
    };

    public static Constant create(String lexicalForm) {
        return s_interningManager.intern(new Constant(lexicalForm));
    }
}
