package uk.ac.ox.cs.goalDriven.model;

import java.io.PrintWriter;
import java.io.Serializable;

public class Function implements Serializable {
    private static final long serialVersionUID = 8590107379133145044L;

    protected final String m_name;

    protected Function(String name) {
        m_name = name;
    }

    public String getName() {
        return m_name;
    }

    public void toString(StringBuilder builder) {
        builder.append(m_name);
    }

    public void print(PrintWriter output) {
        output.print(m_name);
    }

    protected Object readResolve() {
        return s_interningManager.intern(this);
    }

    protected static final InterningManager<Function> s_interningManager = new InterningManager<Function>() {
        protected boolean equal(Function object1, Function object2) {
            return object1.m_name.equals(object2.m_name);
        }

        protected int getHashCode(Function object) {
            return object.m_name.hashCode();
        }
    };

    public static Function create(String name) {
        return s_interningManager.intern(new Function(name));
    }
}
