package uk.ac.ox.cs.goalDriven.model;

import java.io.PrintWriter;
import java.util.Collection;
import java.util.Map;

public abstract class Term {
    public abstract boolean isGround();

    public abstract Term applySubstitution(Map<Variable, ? extends Term> substitution);

    public abstract Term applyMapping(Map<? extends Term, ? extends Term> mapping);

    public String toString() {
        StringBuilder builder = new StringBuilder();
        toString(builder);
        return builder.toString();
    }

    public abstract void toString(StringBuilder builder);

    public abstract void print(PrintWriter output);

    public abstract void getFreeVariables(Collection<Variable> collection);

    public abstract void getConstants(Collection<Constant> collection);

    public abstract void getFunctions(Map<Function,Integer> collection);

    public abstract int depth();

}
