package uk.ac.ox.cs.goalDriven.processors;

import java.util.Collection;
import java.util.List;

import uk.ac.ox.cs.goalDriven.model.Atom;
import uk.ac.ox.cs.goalDriven.model.Constant;
import uk.ac.ox.cs.goalDriven.model.Predicate;
import uk.ac.ox.cs.goalDriven.model.Rule;
import uk.ac.ox.cs.goalDriven.model.Term;

public class InputCollector implements InputProcessor {
    protected final Collection<Rule> m_rules;
    protected final Collection<Atom> m_facts;

    public InputCollector(Collection<Rule> rules, Collection<Atom> facts) {
        m_rules = rules;
        m_facts = facts;
    }

    public void startProcessing() {
    }

    public void processRule(Rule rule) {
        if (m_rules != null)
            m_rules.add(rule);
    }

    public void processFact(Predicate predicate, List<String> argumentLexicalForms) {
        if (m_facts != null) {
            Term[] arguments = new Term[argumentLexicalForms.size()];
            for (int index = 0; index < argumentLexicalForms.size(); ++index) 
                arguments[index] = Constant.create(argumentLexicalForms.get(index));
            m_facts.add(Atom.create(predicate, arguments));
        
        }
    }

    public void endProcessing() {
    }

}
